#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m05__Výrazy.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
5  Jednoduché výrazy.

Co se v kapitole naučíte
Tato kapitola vás nejprve seznámí se základní teorií týkající se
používání operátorů ve výrazech. Poté probere nejdůležitější operátory
pracující s čísly a stringy a naučí vás je používat.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



##### Kapitola 5.0  Asociativita binárních operátorů
###########################################################################q

(16 / 4 / 2)  ==  ((16 / 4) / 2)  ==  (4 / 2)  ==  2
# True

#---------------------------------------------------------------------------

(16 / (4 / 2))  ==  (16 / 2)  ==  8
# True

#---------------------------------------------------------------------------

4 ** 3 ** 2  ==  4 ** (3 ** 2) == 4 ** 9 == 262_144
# True



#Výpis 5.1:	Ukázky tří druhů dělení
###########################################################################q
10 / 3     #Běžný podíl
# 3.3333333333333335
10 // 3    #Celočíselný podíl celých čísel je celé číslo
# 3
10 % 3     #Zbytek po dělení celých čísel je celé číslo
# 1
10 / 5     #Běžný podíl – výsledkem je vždy reálné číslo
# 2.0
10 / 3.5   #Běžný podíl
# 2.857142857142857
10 // 3.5  #Celočíselný podíl reálných čísel je reálné číslo
# 2.0
10 % 3.5   #Zbytek po dělení
# 3.0
# >>>



##### Kapitola 5.2.3  Umocňování
###########################################################################q

4 ** 3 ** 2  ==  4 ** (3 ** 2)  ==  4 ** 9  ==  262_144
# True

#---------------------------------------------------------------------------

(4 ** 3) ** 2  ==  64 ** 2  ==  4096
# True



#Výpis 5.2:	Komplexní číslo jako exponent – Eulerova rovnost
###########################################################################q
2.71828_18284_59045 ** 3.14159_26535_89793j  +  1
# 1.2246467991473532e-16j
round(abs(2.71828_18284_59045 ** 3.14159_26535_89793j + 1), 15)
# 0.0
# >>>



#Výpis 5.3:	Nekonečna a nesmyslná čísla
###########################################################################q
#!# inf
# Traceback (most recent call last):
#   File "<pyshell#108>", line 1, in <module>
#     inf
# NameError: name 'inf' is not defined
float('INF'), float('+Inf'), float('-inf'), -float('inf'), float('NaN')
# (inf, inf, -inf, -inf, nan)
float('-inf') * -float('inf'),  float('inf')/float('inf')
# (inf, nan)
123 / float('inf'), 123 / float('-inf'), -123 / float('-inf')
# (0.0, -0.0, 0.0)
# >>>



#Výpis 5.4:	Sčítání textů
###########################################################################q
"Jedna" + """Dva""" + 'Tři'   '''Čtyři'''
# 'JednaDvaTřiČtyři'
#!# "Jedna: " + 1
# Traceback (most recent call last):
#   File "<pyshell#2>", line 1, in <module>
#     "Jedna: " + 1
# TypeError: can only concatenate str (not "int") to str
"Jedna: " + str(1)
# 'Jedna: 1'
#!# 'Jedna' str(1)
# SyntaxError: invalid syntax
# >>>



#Výpis 5.5:	Násobení textů
###########################################################################q
'Bu' * 3
# 'BuBuBu'
3 * "Ha"
# 'HaHaHa'
#!# 3.0 * "Ha"
# Traceback (most recent call last):
#   File "<pyshell#78>", line 1, in <module>
#     3.0 * "Ha"
# TypeError: can't multiply sequence by non-int of type 'float'
# >>>



#Výpis 5.6:	Indexace stringů
###########################################################################q
'Python'[0]
# 'P'
'Python'[3]
# 'h'
'Python'[-2]
# 'o'
# >>>



#Výpis 5.0: Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
