#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ ó
#R:/71_INP/m24__Práce_se_soubory.py
"""
Příkazy zadávané ve výpisech kapitoly:
24  Práce se soubory.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 24.1:	Zjištění a změna aktuální složky
###########################################################################q
import os
os.getcwd()     # Mnemotechnika: get current working directory
os.chdir('..')  # Mnemotechnika: change directory
os.getcwd()
os.chdir('71_INP');   (cwd:=os.getcwd());   print(cwd)
os.listdir('..')
os.listdir(r'R:\')  # Zpětné lomítko nesmí předcházet závěrečný ')
os.listdir('R:/')



#Výpis 24.2:	Syntéza a analýza cest
###########################################################################q
data = os.path.join(cwd, 'DATA', 'data.txt');   data
os.path.join(cwd, 'výplň', data);   os.path.join(data, cwd, 'výplň')
os.path.join(data, cwd, '/výplň')
(dn := os.path.dirname(data)),   (bn := os.path.basename(data)); \
os.path.split(data);   os.path.splitext(data)
os.path.split(dn);   os.path.split(bn);   os.path.splitext(dn)
os.path.abspath('.');   os.path.relpath(data)



#Výpis 24.3:	Vytváření a mazání složek
###########################################################################q
os.mkdir(tmp := '../TMP')   # Vytvoření nové složky
os.mkdir(tmp)               # Pokus o opětné vytvoření existující složky
aaa = os.path.join(tmp, 'a/aa/aaa');   aaa   # Cesta k vnořené podsložce
os.mkdir(aaa)       # Neexistující složky na cestě k té vytvářené
os.makedirs(aaa)    # Vytváření složky včetně všech potřebných nadsložek
os.path.exists(aaa) # Ověření existence vytvořené složky
os.removedirs(aaa)  # Odstranění složky včetně prázdných nadsložek
os.path.exists(tmp) # Ověření neexistence výchozí nadsložky



#Výpis 24.4:	Získání informací o souborech
###########################################################################q
print(f'{os.path.exists(dn)  }\t{dn   = !s}\n'
      f'{os.path.exists(data)}\t{data = !s}')
os.mkdir(dn);   os.path.exists(dn),   os.path.exists(data)
os.path.getsize('..'),   os.path.getsize('.'),   os.path.getsize(dn)
m10a = 'm10a_Modul.py';   os.path.getsize(m10a)
os.path.isdir('.'),   os.path.isfile('.')
os.path.isdir(m10a),   os.path.isfile(m10a)
os.path.isdir(data),   os.path.isfile(data)



#Výpis 24.5:	Otevření souboru
###########################################################################q
win = os.path.join(aaa, 'win.txt')
def print_paths():
    print(f'{os.path.exists(cwd) }\t{cwd  = !s}\n'
          f'{os.path.exists(dn)  }\t{dn   = !s}\n'
          f'{os.path.exists(data)}\t{data = !s}\n'
          f'{os.path.exists(tmp) }\t{tmp  = !s}\n'
          f'{os.path.exists(aaa) }\t{aaa  = !s}\n'
          f'{os.path.exists(win) }\t{win  = !s}')

print_paths()
os.makedirs(aaa)
fd = open(data, 'w');   fd
fw = open(win,  'w', 1, '1250');   fw
print_paths()



#Výpis 24.6:	Zápis dat, splachování a zavírání souborů
###########################################################################q
pangram = 'Příliš žluťoučký kůň úpěl ďábelské ó.'
from os.path import getsize
print(pangram, file=fd);   print(pangram, file=fw)
print(f'data={getsize(data)} bajtů,   win={getsize(win)} bajtů')
fd.flush()
print(f'data={getsize(data)} bajtů,   win={getsize(win)} bajtů')
print(pangram, file=fd);   print(pangram, file=fw, flush=True)
print(file=fd);            print(file=fw, flush=True)
text = 'Copyright-©, Alpha-α, Beta-β, Smile-☺'
print(text, file=fd)
print(text, file=fw)
fd.close();   fw.close()



#Výpis 24.7:	Čtení souborů
###########################################################################q
with open(data, 'r', 1) as fd:
    while (line:=fd.readline()) != '':
        print(repr(line))

with open(win, encoding='1250') as fw:
    while (line:=fw.read(59)) != '':
        print(repr(line))

fd = open(data)
fd.readlines()
fd.seek(0)   # Přesune aktuální pozici zpět na začátek souboru
with fd:
    for line in fd:
        print(repr(line[:10]), end=' === ')
    print()



#Výpis 24.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
