#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m37d_ModuleProperty.py
"""
Modul demonstrující možnost definice vlastní mateřské třídy
a z toho plynoucí možnost definice vlastností, deskriptorů atd.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q

from types import ModuleType       # Společný rodič všech modulů

class ModuleMother(ModuleType):    # Musí být potomkem ModuleType
    """Nově definovaná mateřská třída modulu."""

    counters = {}   # Každá instance si zde počítá své přístupy

    @property
    def count(self):
        ord = ModuleMother.counters.get(self, 0) + 1
        ModuleMother.counters[self] = ord
        return f'{ord}. přístup k vlastnosti count modulu {self.__name__}'

# Modul musí novou matku nastavit oslovením svého objektu

# Prostřednictvím slovníku se všemi nataženými moduly
import sys      # Modul s atributy používanými interpretem
sys.modules[__name__].__class__ = ModuleMother

# Prostřednictvím importu sebe sama
import m37d_ModuleProperty as m37d
m37d.__class__ = ModuleMother

###########################################################################q
dbg.stop_mod(0, __name__)
