#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m14__Rozhodování.py
"""
Příkazy a záznamy odpovědí zadávané ve výpisech kapitoly:
14  Rozhodování.

Co se v kapitole naučíte
Tato kapitola probere příkazy, v nichž se rozhodujete o dalším postupu.
Nejprve představí podmíněný příkaz s jeho různými modifikacemi,
aby se pak soustředila na novinku verze 3.10, kterou je příkaz match.
Na závěr vás ještě upozorní na některé záludnosti prostředí IDLE
při zadávání složených příkazů v interaktivním režimu.

Společné konvence dodržované v doprovodných programech jsou popsány
v modulu m01__Startujeme.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 14.1:	Ukázka použití jednoduchého podmíněného příkazu
###########################################################################q
def ifThen(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    znaménko = 'plus '  # Předpokládám, že číslo je kladné
    if číslo < 0:       # Oprava pro záporné číslo
        znaménko = 'mínus '
        číslo    = -číslo
    print (znaménko, číslo, sep='');

ifThen(5); ifThen(-7)
# plus 5
# mínus 7
# >>>



#Výpis 14.2:	Ukázka použití úplného podmíněného příkazu
###########################################################################q
def ifElse(číslo):
    """Doplní číslo slovním vyjádřením znaménka."""
    if (číslo > 0):     # Verze pro kladná čísla
        text = f'plus {číslo}'
    else:               # Verze pro záporná čísla
        text = f'mínus {-číslo}'
    print(text)

ifElse(5);    ifElse(-7)
# plus 5
# mínus 7
def ifExpr(číslo):
    """Tiskne hodnotu podmíněného výrazu."""
    print( f'plus {číslo}'  if  (číslo > 0)
      else f'mínus {-číslo}' )

ifExpr(5);    ifExpr(-7)
# plus 5
# mínus 7
# >>>



#Výpis 14.3:	Ukázky použití rozšířeného podmíněného příkazu
###########################################################################q
def jab_1(sezóna):
    """Těla jsou na stejném řádku jako hlavička příkazu."""
    if   sezóna == 'zima'  : činnost = 'spí'
    elif sezóna == 'jaro'  : činnost = 'kvete'
    elif sezóna == 'léto'  : činnost = 'zraje'
    elif sezóna == 'podzim': činnost = 'plodí'
    else: return f'Špatně zadaná sezóna: {sezóna}'
    return f'Je-li {sezóna}, jabloň {činnost}'

print(f"{jab_1('jaro')}\n{jab_1('podzim')}\n{jab_1('nevím')}")
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevím
def jab_2(sezóna):
    """Těla nejsou na stejném řádku jako hlavička příkazu."""
    if   sezóna == 'zima':
         činnost = 'spí'
    elif sezóna == 'jaro':
         činnost = 'kvete'
    elif sezóna == 'léto':
         činnost = 'zraje'
    elif sezóna == 'podzim':
         činnost= 'plodí'
    else:
         return f'Špatně zadaná sezóna: {sezóna}'
    return f'Je-li {sezóna}, jabloň {činnost}'

print(f"{jab_2('jaro')}\n{jab_2('podzim')}\n{jab_2('nevím')}")
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevím
# >>>



#Výpis 14.4:	Řešení jednoduché úlohy prostřednictvím přepínače
###########################################################################q
def jab_m(sezóna):
    """Řešení úlohy prostřednictvím přepínače."""
    match sezóna:
        case 'zima':    činnost = 'spí'
        case 'jaro':    činnost = 'kvete'
        case 'léto':    činnost = 'zraje'
        case 'podzim':  činnost = 'plodí'
        case _:
            return f'Špatně zadaná sezóna: {sezóna}'
    return f'Je-li {sezóna}, jabloň {činnost}'

print(f"{jab_m('jaro')}\n{jab_m('podzim')}\n{jab_m('nevím')}")
# Je-li jaro, jabloň kvete
# Je-li podzim, jabloň plodí
# Špatně zadaná sezóna: nevím
# >>>



#Výpis 14.5:	Ukázka možného sdružování hodnot ve vzorech
###########################################################################q
def match_or(number:int) -> None:
    """Demonstrace možného sdružení hodnot."""
    match(number):
        case 0:                 print(f'{number} je nula')
        case 2 | 4 | 8:         print(f'{number} je kladná mocnina dvou')
        case 1 | 2 | 3 | 5 | 7: print(f'{number} je malé prvočíslo')
        case _:         print(f'{_} je nezajímavý objekt')

_ = '123';   match_or(0);   match_or(2);   match_or(3);   match_or(9)
# 0 je nula
# 2 je kladná mocnina dvou
# 3 je malé prvočíslo
# 123 je nezajímavý objekt
# >>>



#Výpis 14.6:	Přímé zadání podmíněného příkazu v interaktivním režimu
###########################################################################q
číslo = -5
if (číslo > 0):     # Verze pro kladná čísla
    print(f'plus {číslo}')
else:               # Verze pro záporná čísla
    print(f'minus {-číslo}')

# minus 5
# >>>



#Výpis 14.Y:	Popisek
###########################################################################q
dbg.stop_mod (0, __name__)
