#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m27a_LABC.py
"""
Definice demonstračních tříd k výkladu jednoduchého, lineárního dědění.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q

class LA(object):   # Stejný význam má i hlavička bez uvedení předka: class LA:
    """Třída je bezprostředním potomkem třídy object."""
    cA = 'LA_cc'    # Třídní, kterého si potomci nevšímají
    cX = 'LA_cx'    # Třídní zakrývaný potomky
    def __init__(self, id):
        dbg.prSE(0, 1, 'LA.__init__', f'{self.__dict__}')
        self.ID = id         # Uchovaný identifikační argument
        self.iA = 'LA_ic'    # Instanční, kterého si potomci nevšímají
        self.iX = 'LA_ix'    # Instanční přepisovaný v initoru potomka
        dbg.prSE(0, 0, 'LA.__init__', f'{self.__dict__}')
    def __repr__(self):
        return f"{self.__class__.__name__}_{self.ID}"
    def mtdA(self): return f"LA_inst({self})"
    def mtdv(self): return f"LA_virt({self})"

class LB(LA):
    """Třída je dcerou třídy LA => vnučkou třídy object."""
    cB = 'LB_cc'    # Třídní, kterého si potomci nevšímají
    cX = 'LB_cx'    # Třídní zakrývající zděděný a zakrývaný potomky
    def __init__(self, id):
        dbg.prSE(0, 1, 'LB.__init__', f'{self.__dict__}')
        super().__init__(id)
        dbg.prIN(0, f'Po super: {self.__dict__}')
        self.iB = 'LB_ic'    # Instanční, kterého si potomci nevšímají
        self.iX = 'LB_ix'    # Instanční přepisující hodnotu předka
                             # a přepisovaný v initoru potomka
        dbg.prSE(0, 0, 'LB.__init__', f'{self.__dict__}')
    def mtdB(self): return f"LB_inst({self})"
    def mtdv(self): return f"LB_virt({self})"

class LC(LB):
    """Třída je dcerou třídy LB => vnučkou třídy LA
       => pravnučkou třídy object."""
    cC = 'LC_cc'    # Třídní místní
    cX = 'LC_cx'    # Třídní zakrývající zděděný
    def __init__(self, id):
        dbg.prSE(0, 1, 'LC.__init__', f'{self.__dict__}')
        super().__init__(id)
        dbg.prIN(0, f'Po super: {self.__dict__}')
        self.iC = 'LC_ic'    # Instanční místní
        self.iX = 'LC_ix'    # Instanční modifikující zděděný
        dbg.prSE(0, 0, 'LC.__init__', f'{self.__dict__}')
    def mtdC(self): return f"LC_inst({self})"
    def mtdv(self): return f"LC_virt({self})"



###########################################################################q
dbg.stop_mod (0, __name__)
