#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m28c_Komolení.py
"""
Demonstrační třídy pro výklad komolení jmen.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q

class Bc:
    """Třída reprezentující babičku."""
    __count = 0             # Počitadlo vytvořených instancí
    __cpa = 'pr cls Bc'     # Pseudosoukromý atribut
    cpub  = 'pu cls Bc'     # Veřejný atribut
    def __init__(self):
        Bc.__count += 1
        self.ID    = Bc.__count
        self.__ipa ='pr ins Bc'
        self.ipub  ='pu ins Bc'
    def __repr__(self): return f"{self.__class__.__name__}_{self.ID}"
    def __mtd(self):
        return f'Soukr. v Bc pro {self}: \n' \
               f'   {self.__cpa=},   {self.cpub=}\n' \
               f'   {self.__ipa=},   {self.ipub=}'
    def pumtd(self):
        return f'Metoda v Bc pro {self}: \n' \
               f'   {self.__cpa=},   {self.cpub=}\n' \
               f'   {self.__ipa=},   {self.ipub=}'
    def tmpl(self):
        print(f'{self.__mtd()}\n{self.pumtd()}')


class Mc(Bc):
    """Třída reprezentující matku."""
    __cpa = 'pr cls Mc'
    cpub  = 'pu cls Mc'
    def __init__(self):
        super().__init__()
        self.__ipa ='pr ins Mc'
        self.ipub  ='pu ins Mc'
    def __mtd(self):
        return f'Soukr v Mc pro {self}: \n' \
               f'   {self.__cpa=},   {self.cpub=}\n' \
               f'   {self.__ipa=},   {self.ipub=}'
    def pumtd(self):
        return f'Metoda v Mc pro {self}:\n' \
               f'   {self.__cpa=},   {self.cpub=}\n' \
               f'   {self.__ipa=},   {self.ipub=}'



###########################################################################q
dbg.stop_mod (0, __name__)
