#Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
#R:/71_INP/m38d_MetaObj.py
"""
Definice metatřídy MetaObj definované jako objekt.
"""
import dbg
dbg.start_mod(0, __name__)
###########################################################################q



#Výpis 38.8:	Definice metatřídy MetaObj definované v modulu m38d_MetaObj jako objekt
###########################################################################q
class MetaObj:
    def __prepare__(self, classname, supers):
        DICT = {'da': 'MF',  'fa': lambda self: f"{self}"}
        print('MetaObj.__prepare__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"Vracím slovník {DICT=}", sep='\n...')
        return DICT

    def __call__(self, classname, supers, classdict):
        print('MetaObj.__call__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}", sep='\n...')
        CLASS = self.__NEW__(classname, supers, classdict)
        self.__INIT__(CLASS, classname, supers, classdict)
        print('Konec práce MetaObj.call')
        return CLASS

    def __NEW__(self, classname, supers, classdict):
        CLASS = type(classname, supers, classdict)
        print('...MetaObj.__new__: ', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Vytvořena třída {CLASS=}", sep='\n......')
        return CLASS

    def __INIT__(self, CLASS, classname, supers, classdict):
        print('...MetaObj.__init__:', f"{self=}", f"{classname=}",
              f"{supers=}", f"{list(classdict.keys())}",
              f"Inicializována třída {CLASS=}", sep='\n......')



###########################################################################q
# Následuje test funkce metatřídy MetaFce

class Matka38Obj:   """Metatřídou je třída type. """

print('===== Vytvářím třídu =====')
class Dcera38Obj(Matka38Obj, metaclass=MetaObj()):
    """Použitá metatřída MetaObj je definována jako objekt."""
    print('Tělo definované třídy Dcera38Obj spuštěno:')
    data = 'Cls'
    def mtd(self, arg) -> str:
        return f"{self.data}({arg})"
    print('Tělo definované třídy Dcera38Obj ukončeno')

print('===== Vytvářím instanci =====')
do = Dcera38Obj()
print(f"{do.data=}, {do.mtd(1)=}, {do.da=}\n{do.fa()=}",
      f"\n{type(Dcera38Obj)=}")



###########################################################################q
dbg.stop_mod (0, __name__)
